if(NOT UNIX)
  message(FATAL "Cannot build this test script on non-UNIX platform")
endif()

if(DEFINED ENV{CI_COMMIT_TAG})
  set(BUILD_VERSION "$ENV{CI_COMMIT_TAG}")
elseif(DEFINED ENV{CI_COMMIT_SHORT_SHA})
  set(BUILD_VERSION "$ENV{CI_COMMIT_SHORT_SHA}")
else()
  set(BUILD_VERSION "local")
endif()

set(PROJECT_BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

message(STATUS "Setting up ${PROJECT_BASE_DIR}")

set(CTEST_SOURCE_DIRECTORY "${PROJECT_BASE_DIR}/src")
set(CTEST_BINARY_DIRECTORY "${PROJECT_BASE_DIR}/build")

set(CTEST_SITE $ENV{CDASH_SITE})
set(CTEST_DASHBOARD_TYPE $ENV{CDASH_DASHBOARD_TYPE})

message(STATUS "Set up build site and name: ${CTEST_SITE}/${CTEST_BUILD_NAME}")

if(NOT DEFINED CTEST_SITE)
  set(CTEST_SITE "local-station")
endif()

set(CTEST_BUILD_NAME
    "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_VERSION}-${BUILD_VERSION}")

if(NOT DEFINED CTEST_DASHBOARD_TYPE)
  set(CTEST_DASHBOARD_TYPE "Experimental")
endif()

set(CTEST_CMAKE_GENERATOR "Unix Makefiles")
set(CTEST_BUILD_CONFIGURATION "Debug")

set(WITH_MEMCHECK TRUE)
set(WITH_COVERAGE TRUE)

ctest_empty_binary_directory(${CTEST_BINARY_DIRECTORY})

find_program(CTEST_GIT_COMMAND NAMES git)
find_program(CTEST_COVERAGE_COMMAND NAMES gcov)
find_program(CTEST_MEMORYCHECK_COMMAND NAMES valgrind)

set(CTEST_CHECKOUT_COMMAND
    "conan install -if ${CTEST_BINARY_DIRECTORY} ${PROJECT_BASE_DIR}")

set(CTEST_CONFIGURE_COMMAND
    "${CMAKE_COMMAND} -DCMAKE_BUILD_TYPE:STRING=${CTEST_BUILD_CONFIGURATION}")
set(CTEST_CONFIGURE_COMMAND "${CTEST_CONFIGURE_COMMAND} ${CTEST_BUILD_OPTIONS}")
set(CTEST_CONFIGURE_COMMAND
    "${CTEST_CONFIGURE_COMMAND} \"-G${CTEST_CMAKE_GENERATOR}\"")
set(CTEST_CONFIGURE_COMMAND
    "${CTEST_CONFIGURE_COMMAND} \"${CTEST_SOURCE_DIRECTORY}\"")

set(CTEST_BUILD_COMMAND "${CMAKE_COMMAND} --build ${CTEST_BINARY_DIRECTORY}")

ctest_start(${CTEST_DASHBOARD_TYPE})
ctest_configure()
ctest_build()
ctest_test()
if(WITH_COVERAGE AND CTEST_COVERAGE_COMMAND)
  ctest_coverage()
endif()
if(WITH_MEMCHECK AND CTEST_MEMORYCHECK_COMMAND)
  ctest_memcheck()
endif()
ctest_submit(HTTPHEADER "Authorization: Bearer $ENV{CDASH_TOKEN}")
